Strip the LTO dylib.
[oota-llvm.git] / utils / buildit / build_llvm
index b6d0cb731322e2e26e483d9543dc6f427aedb840..df218abe189b74a75944392ca38a37ce7d1c9756 100755 (executable)
@@ -59,6 +59,13 @@ echo DARWIN_VERS = $DARWIN_VERS
 # If the user has CC set in their environment unset it now
 unset CC
 
+DT_HOME=$DEST_DIR/Developer/usr
+DEST_ROOT="/Developer$DEST_ROOT"
+if [ "x$DEVELOPER_BIN" != "x" ]; then
+    DT_HOME=$DEST_DIR/$DEVELOPER_DIR/usr
+    DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
+fi
+
 ################################################################################
 # Run the build.
 
@@ -75,26 +82,64 @@ mkdir -p $DIR/obj-llvm || exit 1
 cd $DIR/obj-llvm || exit 1
 
 if [ \! -f Makefile.config ]; then
-    $SRC_DIR/llvm/configure --prefix=$DEST_DIR$DEST_ROOT \
-        --enable-targets=x86,powerpc,cbe \
+    $SRC_DIR/configure --prefix=$DT_HOME/local \
+        --enable-targets=arm,x86,powerpc,cbe \
         --enable-assertions=$LLVM_ASSERTIONS \
         --enable-optimized=$LLVM_OPTIMIZED \
         || exit 1
 fi
 
+SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
+
+if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
+    LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
+    RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
+    LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
+fi
+
 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
 else
     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
 fi
 
-# Note: Don't pass -jN here.  Building universal already has parallelism and we
-# don't want to make the builders hit swap by firing off too many gcc's at the
-# same time.
-make $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
+GCC_VER=`cc --version 2>/dev/null | sed 1q`
+
+if echo "$GCC_VER" | grep GCC > /dev/null; then
+    GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
+    MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
+    MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
+fi
+
+JOBS_FLAG=""
+
+# Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
+# already has parallelism and we don't want to make the builders hit swap by
+# firing off too many gccs at the same time.
+if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
+    # Figure out how many make processes to run.
+    SYSCTL=`sysctl -n hw.activecpu`
+
+    # hw.activecpu only available in 10.2.6 and later
+    if [ -z "$SYSCTL" ]; then
+        SYSCTL=`sysctl -n hw.ncpu`
+    fi
+
+    # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
+    # Builders can default to 2, since even if they are single processor,
+    # nothing else is running on the machine.
+    if [ -z "$SYSCTL" ]; then
+        SYSCTL=2
+    fi
+
+    JOBS_FLAG="-j $SYSCTL"
+fi
+
+make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
-    CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
+    CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
+    VERBOSE=1
 
 if ! test $? == 0 ; then
     echo "error: LLVM 'make' failed!"
@@ -113,7 +158,10 @@ rm -rf * || exit 1
 cd $DIR/obj-llvm || exit 1
 
 # Install the tree into the destination directory.
-make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 OPTIMIZE_OPTION='-O2' install
+make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
+    LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
+    LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
+    OPTIMIZE_OPTION='-O2' VERBOSE=1 install
 
 if ! test $? == 0 ; then
     echo "error: LLVM 'make install' failed!"
@@ -121,55 +169,47 @@ if ! test $? == 0 ; then
 fi 
 
 # Install Version.h
-if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
-    RC_ProjectSourceSubversion=0
-else
-    case "$LLVM_SUBMIT_SUBVERSION" in
-        01) RC_ProjectSourceSubversion=1 ;;
-        02) RC_ProjectSourceSubversion=2 ;;
-        03) RC_ProjectSourceSubversion=3 ;;
-        04) RC_ProjectSourceSubversion=4 ;;
-        05) RC_ProjectSourceSubversion=5 ;;
-        06) RC_ProjectSourceSubversion=6 ;;
-        07) RC_ProjectSourceSubversion=7 ;;
-        08) RC_ProjectSourceSubversion=8 ;;
-        09) RC_ProjectSourceSubversion=9 ;;
-        *)  RC_ProjectSourceSubversion=$LLVM_SUBMIT_SUBVERSION ;;
-    esac
-fi
-
+RC_ProjectSourceSubversion=`printf "%d" $LLVM_SUBMIT_SUBVERSION`
 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
 
-# Strip local symbols from llvm libraries.
-strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
-strip -Sx $DEST_DIR$DEST_ROOT/lib/*.so
+if [ "x$LLVM_DEBUG" != "x1" ]; then
+    # Strip local symbols from llvm libraries.
+    strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
+    for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
+        strip -Sx $f
+    done
+fi
+
+# Copy over the tblgen utility.
+cp `find $DIR -name tblgen` $DT_HOME/local/bin
 
 # Remove .dir files 
 cd $DEST_DIR$DEST_ROOT
-rm bin/.dir etc/llvm/.dir lib/.dir
+rm -f bin/.dir etc/llvm/.dir lib/.dir
 
 # Remove PPC64 fat slices.
 cd $DEST_DIR$DEST_ROOT/bin
-
 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
-    find . -perm 755 -type f -exec lipo -extract ppc -extract i386 {} -output {} \;
+    find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
+        -exec lipo -extract ppc -extract i386 {} -output {} \;
+elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
+    find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
+        -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
 else
-    find . -perm 755 -type f -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
+    find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
+        -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
 fi
 
 cd $DEST_DIR$DEST_ROOT
-# LTO is part of developer tools
-LTO_HOME=$DEST_DIR//Developer/usr
-if [ "x$DEVELOPER_BIN" != "x" ]; then
-LTO_HOME=$DEST_DIR/$DEVELOPER_DIR/usr
-fi
-
-mkdir -p $LTO_HOME/lib
-mv lib/libLTO.dylib $LTO_HOME/lib/libLTO.dylib
+mkdir -p $DT_HOME/lib
+mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
+strip -S lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
 rm -f lib/libLTO.a lib/libLTO.la
 
-
+# Compress manpages
+MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
+gzip -f $MDIR/*
 
 ################################################################################
 # Create SYM_DIR with information required for debugging.
@@ -217,6 +257,11 @@ find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
 chgrp -h -R wheel $DEST_DIR
 chgrp -R wheel $DEST_DIR
 
+################################################################################
+# Remove tar ball from docs directory
+
+find $DEST_DIR -name html.tar.gz -exec rm {} \;
+
 ################################################################################
 # w00t! Done!